Jonathan Nieder | c74c720 | 2013-11-25 13:03:06 -0800 | [diff] [blame] | 1 | # Test framework for git. See t/README for usage. |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 2 | # |
| 3 | # Copyright (c) 2005 Junio C Hamano |
| 4 | # |
Michal Sojka | 64b9032 | 2010-04-16 15:53:59 +0200 | [diff] [blame] | 5 | # This program is free software: you can redistribute it and/or modify |
| 6 | # it under the terms of the GNU General Public License as published by |
| 7 | # the Free Software Foundation, either version 2 of the License, or |
| 8 | # (at your option) any later version. |
| 9 | # |
| 10 | # This program is distributed in the hope that it will be useful, |
| 11 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 12 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 13 | # GNU General Public License for more details. |
| 14 | # |
| 15 | # You should have received a copy of the GNU General Public License |
| 16 | # along with this program. If not, see http://www.gnu.org/licenses/ . |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 17 | |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 18 | # Test the binaries we have just built. The tests are kept in |
| 19 | # t/ subdirectory and are run in 'trash directory' subdirectory. |
| 20 | if test -z "$TEST_DIRECTORY" |
| 21 | then |
| 22 | # We allow tests to override this, in case they want to run tests |
| 23 | # outside of t/, e.g. for running tests on the test library |
| 24 | # itself. |
| 25 | TEST_DIRECTORY=$(pwd) |
Felipe Contreras | 85176d7 | 2013-11-17 23:12:43 -0500 | [diff] [blame] | 26 | else |
| 27 | # ensure that TEST_DIRECTORY is an absolute path so that it |
| 28 | # is valid even if the current working directory is changed |
| 29 | TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1 |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 30 | fi |
| 31 | if test -z "$TEST_OUTPUT_DIRECTORY" |
| 32 | then |
| 33 | # Similarly, override this to store the test-results subdir |
| 34 | # elsewhere |
| 35 | TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY |
| 36 | fi |
| 37 | GIT_BUILD_DIR="$TEST_DIRECTORY"/.. |
| 38 | |
Jeff King | d0cc579 | 2017-07-10 09:24:35 -0400 | [diff] [blame] | 39 | # If we were built with ASAN, it may complain about leaks |
| 40 | # of program-lifetime variables. Disable it by default to lower |
| 41 | # the noise level. This needs to happen at the start of the script, |
| 42 | # before we even do our "did we build git yet" check (since we don't |
| 43 | # want that one to complain to stderr). |
Jeff King | bf1ce90 | 2017-07-10 09:24:39 -0400 | [diff] [blame] | 44 | : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1} |
Jeff King | d0cc579 | 2017-07-10 09:24:35 -0400 | [diff] [blame] | 45 | export ASAN_OPTIONS |
| 46 | |
Ramkumar Ramachandra | 2006f0a | 2012-09-17 22:36:19 +0530 | [diff] [blame] | 47 | ################################################################ |
| 48 | # It appears that people try to run tests without building... |
| 49 | "$GIT_BUILD_DIR/git" >/dev/null |
| 50 | if test $? != 1 |
| 51 | then |
| 52 | echo >&2 'error: you do not seem to have built git yet.' |
| 53 | exit 1 |
| 54 | fi |
| 55 | |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 56 | . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS |
| 57 | export PERL_PATH SHELL_PATH |
| 58 | |
Ramkumar Ramachandra | 4cde519 | 2012-09-22 10:25:10 +0530 | [diff] [blame] | 59 | # if --tee was passed, write the output not only to the terminal, but |
| 60 | # additionally to the file test-results/$BASENAME.out, too. |
| 61 | case "$GIT_TEST_TEE_STARTED, $* " in |
| 62 | done,*) |
| 63 | # do not redirect again |
| 64 | ;; |
Jeff King | 452320f | 2016-10-21 06:48:00 -0400 | [diff] [blame] | 65 | *' --tee '*|*' --va'*|*' --verbose-log '*) |
John Keeping | 2d14e13 | 2013-04-29 19:16:21 +0100 | [diff] [blame] | 66 | mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results" |
| 67 | BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)" |
Jeff King | 452320f | 2016-10-21 06:48:00 -0400 | [diff] [blame] | 68 | |
| 69 | # Make this filename available to the sub-process in case it is using |
| 70 | # --verbose-log. |
| 71 | GIT_TEST_TEE_OUTPUT_FILE=$BASE.out |
| 72 | export GIT_TEST_TEE_OUTPUT_FILE |
| 73 | |
| 74 | # Truncate before calling "tee -a" to get rid of the results |
| 75 | # from any previous runs. |
| 76 | >"$GIT_TEST_TEE_OUTPUT_FILE" |
| 77 | |
Ramkumar Ramachandra | 4cde519 | 2012-09-22 10:25:10 +0530 | [diff] [blame] | 78 | (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1; |
Jeff King | 452320f | 2016-10-21 06:48:00 -0400 | [diff] [blame] | 79 | echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE" |
Jeff King | 925bdc9 | 2016-10-21 06:42:10 -0400 | [diff] [blame] | 80 | test "$(cat "$BASE.exit")" = 0 |
Ramkumar Ramachandra | 4cde519 | 2012-09-22 10:25:10 +0530 | [diff] [blame] | 81 | exit |
| 82 | ;; |
| 83 | esac |
| 84 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 85 | # For repeatability, reset the environment to known value. |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 86 | # TERM is sanitized below, after saving color control sequences. |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 87 | LANG=C |
Junio C Hamano | 899460f | 2005-10-09 21:58:02 -0700 | [diff] [blame] | 88 | LC_ALL=C |
Pavel Roskin | d9bdd39 | 2005-08-10 22:10:01 -0400 | [diff] [blame] | 89 | PAGER=cat |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 90 | TZ=UTC |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 91 | export LANG LC_ALL PAGER TZ |
Eric Wong | 8ff99e7 | 2006-07-11 12:01:54 -0700 | [diff] [blame] | 92 | EDITOR=: |
Stefano Lattarini | 661bfd1 | 2012-03-02 19:48:36 +0100 | [diff] [blame] | 93 | # A call to "unset" with no arguments causes at least Solaris 10 |
| 94 | # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets |
| 95 | # deriving from the command substitution clustered with the other |
| 96 | # ones. |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 97 | unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e ' |
Jonathan Nieder | 95a1d12 | 2011-03-15 05:10:45 -0500 | [diff] [blame] | 98 | my @env = keys %ENV; |
Jens Lehmann | 730477f | 2011-03-28 21:16:09 +0200 | [diff] [blame] | 99 | my $ok = join("|", qw( |
| 100 | TRACE |
| 101 | DEBUG |
Jens Lehmann | 730477f | 2011-03-28 21:16:09 +0200 | [diff] [blame] | 102 | TEST |
| 103 | .*_TEST |
| 104 | PROVE |
| 105 | VALGRIND |
René Scharfe | ac00128 | 2013-01-06 18:47:57 +0100 | [diff] [blame] | 106 | UNZIP |
Nguyễn Thái Ngọc Duy | edb5408 | 2013-01-15 20:50:56 +0700 | [diff] [blame] | 107 | PERF_ |
Jeff King | e2a0ccc | 2014-05-22 05:28:50 -0400 | [diff] [blame] | 108 | CURL_VERBOSE |
Elia Pinto | 4527aa1 | 2016-09-05 10:24:42 +0000 | [diff] [blame] | 109 | TRACE_CURL |
Jens Lehmann | 730477f | 2011-03-28 21:16:09 +0200 | [diff] [blame] | 110 | )); |
| 111 | my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env); |
Jonathan Nieder | 95a1d12 | 2011-03-15 05:10:45 -0500 | [diff] [blame] | 112 | print join("\n", @vars); |
| 113 | ') |
Jeff King | 5adf84e | 2012-07-24 07:53:05 -0400 | [diff] [blame] | 114 | unset XDG_CONFIG_HOME |
Benoit Person | 8bade1e | 2013-07-04 22:38:55 +0200 | [diff] [blame] | 115 | unset GITPERLLIB |
Junio C Hamano | 29e55cd | 2006-02-10 19:11:23 -0800 | [diff] [blame] | 116 | GIT_AUTHOR_EMAIL=author@example.com |
| 117 | GIT_AUTHOR_NAME='A U Thor' |
Junio C Hamano | 29e55cd | 2006-02-10 19:11:23 -0800 | [diff] [blame] | 118 | GIT_COMMITTER_EMAIL=committer@example.com |
| 119 | GIT_COMMITTER_NAME='C O Mitter' |
Shawn O. Pearce | 8d0fc48 | 2007-02-04 00:45:47 -0500 | [diff] [blame] | 120 | GIT_MERGE_VERBOSITY=5 |
Junio C Hamano | f824628 | 2012-01-10 22:44:45 -0800 | [diff] [blame] | 121 | GIT_MERGE_AUTOEDIT=no |
| 122 | export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT |
Junio C Hamano | 29e55cd | 2006-02-10 19:11:23 -0800 | [diff] [blame] | 123 | export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME |
| 124 | export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME |
Jonathan Nieder | d33738d | 2009-11-11 17:56:07 -0600 | [diff] [blame] | 125 | export EDITOR |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 126 | |
Karsten Blees | 124647c | 2014-07-12 02:03:01 +0200 | [diff] [blame] | 127 | # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output |
| 128 | GIT_TRACE_BARE=1 |
| 129 | export GIT_TRACE_BARE |
| 130 | |
Thomas Gummerer | 5d9fc88 | 2014-02-23 21:49:58 +0100 | [diff] [blame] | 131 | if test -n "${TEST_GIT_INDEX_VERSION:+isset}" |
| 132 | then |
| 133 | GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION" |
| 134 | export GIT_INDEX_VERSION |
| 135 | fi |
| 136 | |
Elia Pinto | a731fa9 | 2012-09-14 09:54:22 -0700 | [diff] [blame] | 137 | # Add libc MALLOC and MALLOC_PERTURB test |
| 138 | # only if we are not executing the test with valgrind |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 139 | if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null || |
René Scharfe | ee1431b | 2012-09-26 22:16:39 +0200 | [diff] [blame] | 140 | test -n "$TEST_NO_MALLOC_CHECK" |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 141 | then |
| 142 | setup_malloc_check () { |
| 143 | : nothing |
| 144 | } |
| 145 | teardown_malloc_check () { |
| 146 | : nothing |
| 147 | } |
| 148 | else |
| 149 | setup_malloc_check () { |
| 150 | MALLOC_CHECK_=3 MALLOC_PERTURB_=165 |
| 151 | export MALLOC_CHECK_ MALLOC_PERTURB_ |
| 152 | } |
| 153 | teardown_malloc_check () { |
| 154 | unset MALLOC_CHECK_ MALLOC_PERTURB_ |
| 155 | } |
| 156 | fi |
Elia Pinto | a731fa9 | 2012-09-14 09:54:22 -0700 | [diff] [blame] | 157 | |
Junio C Hamano | 886a390 | 2007-04-24 11:21:47 -0700 | [diff] [blame] | 158 | # Protect ourselves from common misconfiguration to export |
| 159 | # CDPATH into the environment |
| 160 | unset CDPATH |
| 161 | |
Bert Wesarg | 5565f47 | 2009-11-18 17:15:19 +0100 | [diff] [blame] | 162 | unset GREP_OPTIONS |
René Scharfe | ac00128 | 2013-01-06 18:47:57 +0100 | [diff] [blame] | 163 | unset UNZIP |
Bert Wesarg | 5565f47 | 2009-11-18 17:15:19 +0100 | [diff] [blame] | 164 | |
Robin Rosenberg | 3d5c0cc | 2006-09-23 00:35:20 +0200 | [diff] [blame] | 165 | case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 166 | 1|2|true) |
Jeff King | 025232e | 2015-03-13 00:50:56 -0400 | [diff] [blame] | 167 | GIT_TRACE=4 |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 168 | ;; |
Christian Couder | 6ce4e61 | 2006-09-02 18:23:48 +0200 | [diff] [blame] | 169 | esac |
| 170 | |
Junio C Hamano | cd3c095 | 2009-09-20 11:10:14 -0700 | [diff] [blame] | 171 | # Convenience |
| 172 | # |
| 173 | # A regexp to match 5 and 40 hexdigits |
| 174 | _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]' |
| 175 | _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05" |
| 176 | |
Junio C Hamano | 3749fde | 2011-04-23 22:34:13 -0700 | [diff] [blame] | 177 | # Zero SHA-1 |
| 178 | _z40=0000000000000000000000000000000000000000 |
| 179 | |
Nguyễn Thái Ngọc Duy | f9e7d9f | 2016-07-16 07:06:24 +0200 | [diff] [blame] | 180 | EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904 |
Nguyễn Thái Ngọc Duy | 378932d | 2016-07-16 07:06:25 +0200 | [diff] [blame] | 181 | EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 |
Nguyễn Thái Ngọc Duy | f9e7d9f | 2016-07-16 07:06:24 +0200 | [diff] [blame] | 182 | |
Junio C Hamano | 3f4ab62 | 2011-08-08 11:51:00 -0700 | [diff] [blame] | 183 | # Line feed |
| 184 | LF=' |
| 185 | ' |
| 186 | |
Jeff King | a42643a | 2014-12-15 18:15:20 -0500 | [diff] [blame] | 187 | # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores |
| 188 | # when case-folding filenames |
| 189 | u200c=$(printf '\342\200\214') |
| 190 | |
Nguyễn Thái Ngọc Duy | 378932d | 2016-07-16 07:06:25 +0200 | [diff] [blame] | 191 | export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 192 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 193 | # Each test should start with something like this, after copyright notices: |
| 194 | # |
| 195 | # test_description='Description of this test... |
| 196 | # This test checks if command xyzzy does the right thing... |
| 197 | # ' |
| 198 | # . ./test-lib.sh |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 199 | test "x$TERM" != "xdumb" && ( |
Richard Hansen | ca92a66 | 2015-06-17 15:06:25 -0400 | [diff] [blame] | 200 | test -t 1 && |
| 201 | tput bold >/dev/null 2>&1 && |
| 202 | tput setaf 1 >/dev/null 2>&1 && |
| 203 | tput sgr0 >/dev/null 2>&1 |
| 204 | ) && |
| 205 | color=t |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 206 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 207 | while test "$#" -ne 0 |
| 208 | do |
| 209 | case "$1" in |
| 210 | -d|--d|--de|--deb|--debu|--debug) |
| 211 | debug=t; shift ;; |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 212 | -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate) |
| 213 | immediate=t; shift ;; |
Lea Wiemann | 5e2c08c | 2008-06-17 03:29:02 +0200 | [diff] [blame] | 214 | -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests) |
Junio C Hamano | 91e80b9 | 2009-02-18 11:17:27 -0800 | [diff] [blame] | 215 | GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;; |
Ilya Bobyr | 0445e6f | 2014-04-30 02:50:44 -0700 | [diff] [blame] | 216 | -r) |
| 217 | shift; test "$#" -ne 0 || { |
| 218 | echo 'error: -r requires an argument' >&2; |
| 219 | exit 1; |
| 220 | } |
| 221 | run_list=$1; shift ;; |
| 222 | --run=*) |
SZEDER Gábor | 0ff7410 | 2016-04-22 22:32:21 +0200 | [diff] [blame] | 223 | run_list=${1#--*=}; shift ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 224 | -h|--h|--he|--hel|--help) |
Michele Ballabio | 570f322 | 2007-11-10 15:17:25 +0100 | [diff] [blame] | 225 | help=t; shift ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 226 | -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose) |
| 227 | verbose=t; shift ;; |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 228 | --verbose-only=*) |
SZEDER Gábor | 0ff7410 | 2016-04-22 22:32:21 +0200 | [diff] [blame] | 229 | verbose_only=${1#--*=} |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 230 | shift ;; |
Pierre Habouzit | 1ece127 | 2007-10-24 22:03:39 +0200 | [diff] [blame] | 231 | -q|--q|--qu|--qui|--quie|--quiet) |
Ævar Arnfjörð Bjarmason | 092c433 | 2010-07-31 16:40:05 +0000 | [diff] [blame] | 232 | # Ignore --quiet under a TAP::Harness. Saying how many tests |
| 233 | # passed without the ok/not ok details is always an error. |
| 234 | test -z "$HARNESS_ACTIVE" && quiet=t; shift ;; |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 235 | --with-dashes) |
| 236 | with_dashes=t; shift ;; |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 237 | --no-color) |
Clemens Buchacher | faa4bc3 | 2008-02-27 20:28:45 +0100 | [diff] [blame] | 238 | color=; shift ;; |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 239 | --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind) |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 240 | valgrind=memcheck |
| 241 | shift ;; |
| 242 | --valgrind=*) |
SZEDER Gábor | 0ff7410 | 2016-04-22 22:32:21 +0200 | [diff] [blame] | 243 | valgrind=${1#--*=} |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 244 | shift ;; |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 245 | --valgrind-only=*) |
SZEDER Gábor | 0ff7410 | 2016-04-22 22:32:21 +0200 | [diff] [blame] | 246 | valgrind_only=${1#--*=} |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 247 | shift ;; |
Johannes Schindelin | 4413855 | 2009-02-04 00:26:12 +0100 | [diff] [blame] | 248 | --tee) |
| 249 | shift ;; # was handled already |
Jeff King | f423ef5 | 2009-08-09 04:39:45 -0400 | [diff] [blame] | 250 | --root=*) |
SZEDER Gábor | 0ff7410 | 2016-04-22 22:32:21 +0200 | [diff] [blame] | 251 | root=${1#--*=} |
Jeff King | f423ef5 | 2009-08-09 04:39:45 -0400 | [diff] [blame] | 252 | shift ;; |
Jeff King | bb79af9 | 2015-03-20 06:05:48 -0400 | [diff] [blame] | 253 | --chain-lint) |
| 254 | GIT_TEST_CHAIN_LINT=1 |
| 255 | shift ;; |
| 256 | --no-chain-lint) |
| 257 | GIT_TEST_CHAIN_LINT=0 |
| 258 | shift ;; |
Jeff King | a136f6d | 2014-10-10 02:47:27 -0400 | [diff] [blame] | 259 | -x) |
| 260 | trace=t |
| 261 | verbose=t |
| 262 | shift ;; |
Jeff King | 452320f | 2016-10-21 06:48:00 -0400 | [diff] [blame] | 263 | --verbose-log) |
| 264 | verbose_log=t |
| 265 | shift ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 266 | *) |
Clemens Buchacher | 1f729dc | 2009-06-01 14:14:40 +0200 | [diff] [blame] | 267 | echo "error: unknown test option '$1'" >&2; exit 1 ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 268 | esac |
| 269 | done |
| 270 | |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 271 | if test -n "$valgrind_only" |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 272 | then |
| 273 | test -z "$valgrind" && valgrind=memcheck |
| 274 | test -z "$verbose" && verbose_only="$valgrind_only" |
| 275 | elif test -n "$valgrind" |
| 276 | then |
| 277 | verbose=t |
| 278 | fi |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 279 | |
Richard Hansen | ca92a66 | 2015-06-17 15:06:25 -0400 | [diff] [blame] | 280 | if test -n "$color" |
| 281 | then |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 282 | # Save the color control sequences now rather than run tput |
| 283 | # each time say_color() is called. This is done for two |
| 284 | # reasons: |
| 285 | # * TERM will be changed to dumb |
| 286 | # * HOME will be changed to a temporary directory and tput |
| 287 | # might need to read ~/.terminfo from the original HOME |
| 288 | # directory to get the control sequences |
| 289 | # Note: This approach assumes the control sequences don't end |
| 290 | # in a newline for any terminal of interest (command |
| 291 | # substitutions strip trailing newlines). Given that most |
| 292 | # (all?) terminals in common use are related to ECMA-48, this |
| 293 | # shouldn't be a problem. |
| 294 | say_color_error=$(tput bold; tput setaf 1) # bold red |
| 295 | say_color_skip=$(tput setaf 4) # blue |
| 296 | say_color_warn=$(tput setaf 3) # brown/yellow |
| 297 | say_color_pass=$(tput setaf 2) # green |
| 298 | say_color_info=$(tput setaf 6) # cyan |
| 299 | say_color_reset=$(tput sgr0) |
| 300 | say_color_="" # no formatting for normal text |
Richard Hansen | ca92a66 | 2015-06-17 15:06:25 -0400 | [diff] [blame] | 301 | say_color () { |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 302 | test -z "$1" && test -n "$quiet" && return |
| 303 | eval "say_color_color=\$say_color_$1" |
Richard Hansen | ca92a66 | 2015-06-17 15:06:25 -0400 | [diff] [blame] | 304 | shift |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 305 | printf "%s\\n" "$say_color_color$*$say_color_reset" |
Richard Hansen | ca92a66 | 2015-06-17 15:06:25 -0400 | [diff] [blame] | 306 | } |
| 307 | else |
| 308 | say_color() { |
| 309 | test -z "$1" && test -n "$quiet" && return |
| 310 | shift |
| 311 | printf "%s\n" "$*" |
| 312 | } |
| 313 | fi |
| 314 | |
Richard Hansen | d5c1b7c | 2015-06-17 17:11:21 -0400 | [diff] [blame] | 315 | TERM=dumb |
| 316 | export TERM |
| 317 | |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 318 | error () { |
| 319 | say_color error "error: $*" |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 320 | GIT_EXIT_OK=t |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 321 | exit 1 |
| 322 | } |
| 323 | |
| 324 | say () { |
| 325 | say_color info "$*" |
| 326 | } |
| 327 | |
Jeff King | 614fe01 | 2016-10-22 00:45:06 -0400 | [diff] [blame] | 328 | if test -n "$HARNESS_ACTIVE" |
| 329 | then |
| 330 | if test "$verbose" = t || test -n "$verbose_only" |
| 331 | then |
| 332 | printf 'Bail out! %s\n' \ |
| 333 | 'verbose mode forbidden under TAP harness; try --verbose-log' |
| 334 | exit 1 |
| 335 | fi |
| 336 | fi |
| 337 | |
Michele Ballabio | 570f322 | 2007-11-10 15:17:25 +0100 | [diff] [blame] | 338 | test "${test_description}" != "" || |
| 339 | error "Test script did not set test_description." |
| 340 | |
| 341 | if test "$help" = "t" |
| 342 | then |
Uwe Storbeck | cb1aefd | 2014-03-18 01:14:11 +0100 | [diff] [blame] | 343 | printf '%s\n' "$test_description" |
Michele Ballabio | 570f322 | 2007-11-10 15:17:25 +0100 | [diff] [blame] | 344 | exit 0 |
| 345 | fi |
| 346 | |
Pavel Roskin | 4d9d62f | 2005-08-10 23:56:21 -0400 | [diff] [blame] | 347 | exec 5>&1 |
Jeff King | 781f76b | 2011-12-15 01:55:29 -0500 | [diff] [blame] | 348 | exec 6<&0 |
SZEDER Gábor | 4ecae3c | 2017-03-18 17:13:59 +0100 | [diff] [blame] | 349 | exec 7>&2 |
Jeff King | 452320f | 2016-10-21 06:48:00 -0400 | [diff] [blame] | 350 | if test "$verbose_log" = "t" |
| 351 | then |
| 352 | exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3 |
| 353 | elif test "$verbose" = "t" |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 354 | then |
| 355 | exec 4>&2 3>&1 |
| 356 | else |
| 357 | exec 4>/dev/null 3>/dev/null |
| 358 | fi |
| 359 | |
Jeff King | d88785e | 2016-05-11 09:44:04 -0400 | [diff] [blame] | 360 | # Send any "-x" output directly to stderr to avoid polluting tests |
| 361 | # which capture stderr. We can do this unconditionally since it |
| 362 | # has no effect if tracing isn't turned on. |
| 363 | # |
| 364 | # Note that this sets up the trace fd as soon as we assign the variable, so it |
| 365 | # must come after the creation of descriptor 4 above. Likewise, we must never |
| 366 | # unset this, as it has the side effect of closing descriptor 4, which we |
| 367 | # use to show verbose tests to the user. |
| 368 | # |
| 369 | # Note also that we don't need or want to export it. The tracing is local to |
| 370 | # this shell, and we would not want to influence any shells we exec. |
| 371 | BASH_XTRACEFD=4 |
| 372 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 373 | test_failure=0 |
| 374 | test_count=0 |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 375 | test_fixed=0 |
| 376 | test_broken=0 |
Sverre Rabbelier | 2d84e9f | 2008-06-08 16:04:33 +0200 | [diff] [blame] | 377 | test_success=0 |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 378 | |
Ævar Arnfjörð Bjarmason | d998bd4 | 2010-06-24 17:44:46 +0000 | [diff] [blame] | 379 | test_external_has_tap=0 |
| 380 | |
Clemens Buchacher | faa4bc3 | 2008-02-27 20:28:45 +0100 | [diff] [blame] | 381 | die () { |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 382 | code=$? |
| 383 | if test -n "$GIT_EXIT_OK" |
| 384 | then |
| 385 | exit $code |
| 386 | else |
| 387 | echo >&5 "FATAL: Unexpected exit with code $code" |
| 388 | exit 1 |
| 389 | fi |
Clemens Buchacher | faa4bc3 | 2008-02-27 20:28:45 +0100 | [diff] [blame] | 390 | } |
| 391 | |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 392 | GIT_EXIT_OK= |
Markus Heidelberg | 3564131 | 2009-01-20 00:43:26 +0100 | [diff] [blame] | 393 | trap 'die' EXIT |
Jeff King | da70654 | 2015-03-13 00:48:48 -0400 | [diff] [blame] | 394 | trap 'exit $?' INT |
Pavel Roskin | 4118427 | 2005-08-11 12:00:40 -0400 | [diff] [blame] | 395 | |
Thomas Rast | 12a29b1 | 2012-02-17 11:25:08 +0100 | [diff] [blame] | 396 | # The user-facing functions are loaded from a separate file so that |
| 397 | # test_perf subshells can have them too |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 398 | . "$TEST_DIRECTORY/test-lib-functions.sh" |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 399 | |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 400 | # You are not expected to call test_ok_ and test_failure_ directly, use |
Torstein Hegge | 3fa3666 | 2013-10-27 10:56:33 +0100 | [diff] [blame] | 401 | # the test_expect_* functions instead. |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 402 | |
| 403 | test_ok_ () { |
Johannes Sixt | d5d9de1 | 2009-02-05 20:59:27 +0100 | [diff] [blame] | 404 | test_success=$(($test_success + 1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 405 | say_color "" "ok $test_count - $@" |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 406 | } |
| 407 | |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 408 | test_failure_ () { |
Johannes Sixt | d5d9de1 | 2009-02-05 20:59:27 +0100 | [diff] [blame] | 409 | test_failure=$(($test_failure + 1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 410 | say_color error "not ok $test_count - $1" |
Junio C Hamano | bf0dd8a | 2005-07-22 19:09:34 -0700 | [diff] [blame] | 411 | shift |
Uwe Storbeck | cb1aefd | 2014-03-18 01:14:11 +0100 | [diff] [blame] | 412 | printf '%s\n' "$*" | sed -e 's/^/# /' |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 413 | test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; } |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 414 | } |
| 415 | |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 416 | test_known_broken_ok_ () { |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 417 | test_fixed=$(($test_fixed+1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 418 | say_color error "ok $test_count - $@ # TODO known breakage vanished" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 419 | } |
| 420 | |
| 421 | test_known_broken_failure_ () { |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 422 | test_broken=$(($test_broken+1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 423 | say_color warn "not ok $test_count - $@ # TODO known breakage" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 424 | } |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 425 | |
| 426 | test_debug () { |
Junio C Hamano | 8e832eb | 2005-08-10 22:53:27 -0700 | [diff] [blame] | 427 | test "$debug" = "" || eval "$1" |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 428 | } |
| 429 | |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 430 | match_pattern_list () { |
| 431 | arg="$1" |
| 432 | shift |
| 433 | test -z "$*" && return 1 |
| 434 | for pattern_ |
| 435 | do |
| 436 | case "$arg" in |
| 437 | $pattern_) |
| 438 | return 0 |
| 439 | esac |
| 440 | done |
| 441 | return 1 |
| 442 | } |
| 443 | |
Ilya Bobyr | 0445e6f | 2014-04-30 02:50:44 -0700 | [diff] [blame] | 444 | match_test_selector_list () { |
| 445 | title="$1" |
| 446 | shift |
| 447 | arg="$1" |
| 448 | shift |
| 449 | test -z "$1" && return 0 |
| 450 | |
| 451 | # Both commas and whitespace are accepted as separators. |
| 452 | OLDIFS=$IFS |
| 453 | IFS=' ,' |
| 454 | set -- $1 |
| 455 | IFS=$OLDIFS |
| 456 | |
| 457 | # If the first selector is negative we include by default. |
| 458 | include= |
| 459 | case "$1" in |
| 460 | !*) include=t ;; |
| 461 | esac |
| 462 | |
| 463 | for selector |
| 464 | do |
| 465 | orig_selector=$selector |
| 466 | |
| 467 | positive=t |
| 468 | case "$selector" in |
| 469 | !*) |
| 470 | positive= |
| 471 | selector=${selector##?} |
| 472 | ;; |
| 473 | esac |
| 474 | |
| 475 | test -z "$selector" && continue |
| 476 | |
| 477 | case "$selector" in |
| 478 | *-*) |
| 479 | if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null |
| 480 | then |
| 481 | echo "error: $title: invalid non-numeric in range" \ |
| 482 | "start: '$orig_selector'" >&2 |
| 483 | exit 1 |
| 484 | fi |
| 485 | if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null |
| 486 | then |
| 487 | echo "error: $title: invalid non-numeric in range" \ |
| 488 | "end: '$orig_selector'" >&2 |
| 489 | exit 1 |
| 490 | fi |
| 491 | ;; |
| 492 | *) |
| 493 | if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null |
| 494 | then |
| 495 | echo "error: $title: invalid non-numeric in test" \ |
| 496 | "selector: '$orig_selector'" >&2 |
| 497 | exit 1 |
| 498 | fi |
| 499 | esac |
| 500 | |
| 501 | # Short cut for "obvious" cases |
| 502 | test -z "$include" && test -z "$positive" && continue |
| 503 | test -n "$include" && test -n "$positive" && continue |
| 504 | |
| 505 | case "$selector" in |
| 506 | -*) |
| 507 | if test $arg -le ${selector#-} |
| 508 | then |
| 509 | include=$positive |
| 510 | fi |
| 511 | ;; |
| 512 | *-) |
| 513 | if test $arg -ge ${selector%-} |
| 514 | then |
| 515 | include=$positive |
| 516 | fi |
| 517 | ;; |
| 518 | *-*) |
| 519 | if test ${selector%%-*} -le $arg \ |
| 520 | && test $arg -le ${selector#*-} |
| 521 | then |
| 522 | include=$positive |
| 523 | fi |
| 524 | ;; |
| 525 | *) |
| 526 | if test $arg -eq $selector |
| 527 | then |
| 528 | include=$positive |
| 529 | fi |
| 530 | ;; |
| 531 | esac |
| 532 | done |
| 533 | |
| 534 | test -n "$include" |
| 535 | } |
| 536 | |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 537 | maybe_teardown_verbose () { |
| 538 | test -z "$verbose_only" && return |
| 539 | exec 4>/dev/null 3>/dev/null |
| 540 | verbose= |
| 541 | } |
| 542 | |
| 543 | last_verbose=t |
| 544 | maybe_setup_verbose () { |
| 545 | test -z "$verbose_only" && return |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 546 | if match_pattern_list $test_count $verbose_only |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 547 | then |
| 548 | exec 4>&2 3>&1 |
| 549 | # Emit a delimiting blank line when going from |
| 550 | # non-verbose to verbose. Within verbose mode the |
| 551 | # delimiter is printed by test_expect_*. The choice |
| 552 | # of the initial $last_verbose is such that before |
| 553 | # test 1, we do not print it. |
| 554 | test -z "$last_verbose" && echo >&3 "" |
| 555 | verbose=t |
| 556 | else |
| 557 | exec 4>/dev/null 3>/dev/null |
| 558 | verbose= |
| 559 | fi |
| 560 | last_verbose=$verbose |
| 561 | } |
| 562 | |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 563 | maybe_teardown_valgrind () { |
| 564 | test -z "$GIT_VALGRIND" && return |
| 565 | GIT_VALGRIND_ENABLED= |
| 566 | } |
| 567 | |
| 568 | maybe_setup_valgrind () { |
| 569 | test -z "$GIT_VALGRIND" && return |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 570 | if test -z "$valgrind_only" |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 571 | then |
| 572 | GIT_VALGRIND_ENABLED=t |
| 573 | return |
| 574 | fi |
| 575 | GIT_VALGRIND_ENABLED= |
| 576 | if match_pattern_list $test_count $valgrind_only |
| 577 | then |
| 578 | GIT_VALGRIND_ENABLED=t |
| 579 | fi |
| 580 | } |
| 581 | |
Jeff King | 9b5fe78 | 2015-08-06 01:33:57 -0400 | [diff] [blame] | 582 | want_trace () { |
| 583 | test "$trace" = t && test "$verbose" = t |
| 584 | } |
| 585 | |
Jeff King | a136f6d | 2014-10-10 02:47:27 -0400 | [diff] [blame] | 586 | # This is a separate function because some tests use |
| 587 | # "return" to end a test_expect_success block early |
| 588 | # (and we want to make sure we run any cleanup like |
| 589 | # "set +x"). |
| 590 | test_eval_inner_ () { |
| 591 | # Do not add anything extra (including LF) after '$*' |
| 592 | eval " |
Jeff King | 9b5fe78 | 2015-08-06 01:33:57 -0400 | [diff] [blame] | 593 | want_trace && set -x |
Jeff King | a136f6d | 2014-10-10 02:47:27 -0400 | [diff] [blame] | 594 | $*" |
| 595 | } |
| 596 | |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 597 | test_eval_ () { |
Jeff King | a136f6d | 2014-10-10 02:47:27 -0400 | [diff] [blame] | 598 | # We run this block with stderr redirected to avoid extra cruft |
| 599 | # during a "-x" trace. Once in "set -x" mode, we cannot prevent |
| 600 | # the shell from printing the "set +x" to turn it off (nor the saving |
| 601 | # of $? before that). But we can make sure that the output goes to |
| 602 | # /dev/null. |
| 603 | # |
| 604 | # The test itself is run with stderr put back to &4 (so either to |
| 605 | # /dev/null, or to the original stderr if --verbose was used). |
| 606 | { |
| 607 | test_eval_inner_ "$@" </dev/null >&3 2>&4 |
| 608 | test_eval_ret_=$? |
Jeff King | 9b5fe78 | 2015-08-06 01:33:57 -0400 | [diff] [blame] | 609 | if want_trace |
Jeff King | a136f6d | 2014-10-10 02:47:27 -0400 | [diff] [blame] | 610 | then |
| 611 | set +x |
| 612 | if test "$test_eval_ret_" != 0 |
| 613 | then |
| 614 | say_color error >&4 "error: last command exited with \$?=$test_eval_ret_" |
| 615 | fi |
| 616 | fi |
| 617 | } 2>/dev/null |
| 618 | return $test_eval_ret_ |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 619 | } |
| 620 | |
Pavel Roskin | 4d9d62f | 2005-08-10 23:56:21 -0400 | [diff] [blame] | 621 | test_run_ () { |
Jonathan Nieder | b6b0afd | 2010-05-06 03:41:10 -0500 | [diff] [blame] | 622 | test_cleanup=: |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 623 | expecting_failure=$2 |
Jeff King | bb79af9 | 2015-03-20 06:05:48 -0400 | [diff] [blame] | 624 | |
Jeff King | 92b269f | 2015-04-22 16:09:57 -0400 | [diff] [blame] | 625 | if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then |
Jeff King | 2a01ef8 | 2015-08-06 01:31:47 -0400 | [diff] [blame] | 626 | # turn off tracing for this test-eval, as it simply creates |
| 627 | # confusing noise in the "-x" output |
| 628 | trace_tmp=$trace |
| 629 | trace= |
Jeff King | bb79af9 | 2015-03-20 06:05:48 -0400 | [diff] [blame] | 630 | # 117 is magic because it is unlikely to match the exit |
| 631 | # code of other programs |
Junio C Hamano | 99a64e4 | 2017-03-22 22:43:18 -0700 | [diff] [blame] | 632 | if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" |
| 633 | then |
| 634 | error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1" |
Jeff King | bb79af9 | 2015-03-20 06:05:48 -0400 | [diff] [blame] | 635 | fi |
Jeff King | 2a01ef8 | 2015-08-06 01:31:47 -0400 | [diff] [blame] | 636 | trace=$trace_tmp |
Jeff King | bb79af9 | 2015-03-20 06:05:48 -0400 | [diff] [blame] | 637 | fi |
| 638 | |
Thomas Rast | a57397b | 2013-06-17 11:18:46 +0200 | [diff] [blame] | 639 | setup_malloc_check |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 640 | test_eval_ "$1" |
Jonathan Nieder | b6b0afd | 2010-05-06 03:41:10 -0500 | [diff] [blame] | 641 | eval_ret=$? |
Thomas Rast | a57397b | 2013-06-17 11:18:46 +0200 | [diff] [blame] | 642 | teardown_malloc_check |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 643 | |
Jeff King | a136f6d | 2014-10-10 02:47:27 -0400 | [diff] [blame] | 644 | if test -z "$immediate" || test $eval_ret = 0 || |
| 645 | test -n "$expecting_failure" && test "$test_cleanup" != ":" |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 646 | then |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 647 | setup_malloc_check |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 648 | test_eval_ "$test_cleanup" |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 649 | teardown_malloc_check |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 650 | fi |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 651 | if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE" |
| 652 | then |
Ævar Arnfjörð Bjarmason | 57e1538 | 2010-06-24 17:44:47 +0000 | [diff] [blame] | 653 | echo "" |
| 654 | fi |
Jonathan Nieder | aa0bcf9 | 2011-08-08 03:15:34 +0200 | [diff] [blame] | 655 | return "$eval_ret" |
Pavel Roskin | 4d9d62f | 2005-08-10 23:56:21 -0400 | [diff] [blame] | 656 | } |
| 657 | |
Thomas Rast | ae75342 | 2013-06-18 14:25:59 +0200 | [diff] [blame] | 658 | test_start_ () { |
Johannes Sixt | 8586f98 | 2009-02-05 21:20:56 +0100 | [diff] [blame] | 659 | test_count=$(($test_count+1)) |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 660 | maybe_setup_verbose |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 661 | maybe_setup_valgrind |
Thomas Rast | ae75342 | 2013-06-18 14:25:59 +0200 | [diff] [blame] | 662 | } |
| 663 | |
| 664 | test_finish_ () { |
| 665 | echo >&3 "" |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 666 | maybe_teardown_valgrind |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 667 | maybe_teardown_verbose |
Thomas Rast | ae75342 | 2013-06-18 14:25:59 +0200 | [diff] [blame] | 668 | } |
| 669 | |
| 670 | test_skip () { |
Junio C Hamano | 04ece59 | 2006-12-28 17:58:00 -0800 | [diff] [blame] | 671 | to_skip= |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 672 | skipped_reason= |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 673 | if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS |
| 674 | then |
| 675 | to_skip=t |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 676 | skipped_reason="GIT_SKIP_TESTS" |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 677 | fi |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 678 | if test -z "$to_skip" && test -n "$test_prereq" && |
| 679 | ! test_have_prereq "$test_prereq" |
Johannes Sixt | a7bb394 | 2009-03-01 21:04:46 +0100 | [diff] [blame] | 680 | then |
| 681 | to_skip=t |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 682 | |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 683 | of_prereq= |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 684 | if test "$missing_prereq" != "$test_prereq" |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 685 | then |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 686 | of_prereq=" of $test_prereq" |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 687 | fi |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 688 | skipped_reason="missing $missing_prereq${of_prereq}" |
| 689 | fi |
Ilya Bobyr | 0445e6f | 2014-04-30 02:50:44 -0700 | [diff] [blame] | 690 | if test -z "$to_skip" && test -n "$run_list" && |
| 691 | ! match_test_selector_list '--run' $test_count "$run_list" |
| 692 | then |
| 693 | to_skip=t |
| 694 | skipped_reason="--run" |
| 695 | fi |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 696 | |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 697 | case "$to_skip" in |
| 698 | t) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 699 | say_color skip >&3 "skipping test: $@" |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 700 | say_color skip "ok $test_count # skip $1 ($skipped_reason)" |
Junio C Hamano | 04ece59 | 2006-12-28 17:58:00 -0800 | [diff] [blame] | 701 | : true |
| 702 | ;; |
| 703 | *) |
| 704 | false |
| 705 | ;; |
| 706 | esac |
| 707 | } |
| 708 | |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 709 | # stub; perf-lib overrides it |
| 710 | test_at_end_hook_ () { |
| 711 | : |
| 712 | } |
| 713 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 714 | test_done () { |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 715 | GIT_EXIT_OK=t |
Sverre Rabbelier | 2d84e9f | 2008-06-08 16:04:33 +0200 | [diff] [blame] | 716 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 717 | if test -z "$HARNESS_ACTIVE" |
| 718 | then |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 719 | test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results" |
Ævar Arnfjörð Bjarmason | 8ef1abe | 2010-08-11 19:37:31 +0000 | [diff] [blame] | 720 | mkdir -p "$test_results_dir" |
Felipe Contreras | dd78478 | 2012-11-04 03:13:33 +0100 | [diff] [blame] | 721 | base=${0##*/} |
Jeff King | 5c885c1 | 2016-08-30 04:43:57 -0400 | [diff] [blame] | 722 | test_results_path="$test_results_dir/${base%.sh}.counts" |
Ævar Arnfjörð Bjarmason | 8ef1abe | 2010-08-11 19:37:31 +0000 | [diff] [blame] | 723 | |
Jeff King | 5c885c1 | 2016-08-30 04:43:57 -0400 | [diff] [blame] | 724 | cat >"$test_results_path" <<-EOF |
Mathias Lafeldt | c54e6be | 2011-04-29 14:30:30 +0200 | [diff] [blame] | 725 | total $test_count |
| 726 | success $test_success |
| 727 | fixed $test_fixed |
| 728 | broken $test_broken |
| 729 | failed $test_failure |
| 730 | |
| 731 | EOF |
Ævar Arnfjörð Bjarmason | 8ef1abe | 2010-08-11 19:37:31 +0000 | [diff] [blame] | 732 | fi |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 733 | |
| 734 | if test "$test_fixed" != 0 |
| 735 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 736 | say_color error "# $test_fixed known breakage(s) vanished; please update test(s)" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 737 | fi |
| 738 | if test "$test_broken" != 0 |
| 739 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 740 | say_color warn "# still have $test_broken known breakage(s)" |
Adam Spiers | b73d9a2 | 2012-12-16 18:28:15 +0000 | [diff] [blame] | 741 | fi |
| 742 | if test "$test_broken" != 0 || test "$test_fixed" != 0 |
| 743 | then |
| 744 | test_remaining=$(( $test_count - $test_broken - $test_fixed )) |
| 745 | msg="remaining $test_remaining test(s)" |
Junio C Hamano | 11d54b8 | 2008-02-03 00:23:02 -0800 | [diff] [blame] | 746 | else |
Adam Spiers | b73d9a2 | 2012-12-16 18:28:15 +0000 | [diff] [blame] | 747 | test_remaining=$test_count |
Junio C Hamano | 11d54b8 | 2008-02-03 00:23:02 -0800 | [diff] [blame] | 748 | msg="$test_count test(s)" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 749 | fi |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 750 | case "$test_failure" in |
Junio C Hamano | 10b94e2 | 2005-12-09 17:32:18 -0800 | [diff] [blame] | 751 | 0) |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 752 | if test $test_external_has_tap -eq 0 |
| 753 | then |
Adam Spiers | b73d9a2 | 2012-12-16 18:28:15 +0000 | [diff] [blame] | 754 | if test $test_remaining -gt 0 |
Ramsay Jones | d87bd7c | 2012-09-01 19:26:21 +0100 | [diff] [blame] | 755 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 756 | say_color pass "# passed all $msg" |
Ramsay Jones | d87bd7c | 2012-09-01 19:26:21 +0100 | [diff] [blame] | 757 | fi |
Junio C Hamano | c7018be | 2017-05-18 11:52:20 +0900 | [diff] [blame] | 758 | |
| 759 | # Maybe print SKIP message |
| 760 | test -z "$skip_all" || skip_all="# SKIP $skip_all" |
| 761 | case "$test_count" in |
| 762 | 0) |
| 763 | say "1..$test_count${skip_all:+ $skip_all}" |
| 764 | ;; |
| 765 | *) |
| 766 | test -z "$skip_all" || |
| 767 | say_color warn "$skip_all" |
| 768 | say "1..$test_count" |
| 769 | ;; |
| 770 | esac |
Ævar Arnfjörð Bjarmason | d998bd4 | 2010-06-24 17:44:46 +0000 | [diff] [blame] | 771 | fi |
Johannes Schindelin | abc5d37 | 2008-08-08 13:08:37 +0200 | [diff] [blame] | 772 | |
Junio C Hamano | 06478da | 2017-04-23 17:15:09 -0700 | [diff] [blame] | 773 | if test -z "$debug" |
Junio C Hamano | 4d0912a | 2017-04-24 23:39:47 -0700 | [diff] [blame] | 774 | then |
Junio C Hamano | 06478da | 2017-04-23 17:15:09 -0700 | [diff] [blame] | 775 | test -d "$TRASH_DIRECTORY" || |
Junio C Hamano | 4d0912a | 2017-04-24 23:39:47 -0700 | [diff] [blame] | 776 | error "Tests passed but trash directory already removed before test cleanup; aborting" |
Johannes Schindelin | abc5d37 | 2008-08-08 13:08:37 +0200 | [diff] [blame] | 777 | |
Junio C Hamano | 06478da | 2017-04-23 17:15:09 -0700 | [diff] [blame] | 778 | cd "$TRASH_DIRECTORY/.." && |
| 779 | rm -fr "$TRASH_DIRECTORY" || |
Junio C Hamano | 4d0912a | 2017-04-24 23:39:47 -0700 | [diff] [blame] | 780 | error "Tests passed but test cleanup failed; aborting" |
Junio C Hamano | 4d0912a | 2017-04-24 23:39:47 -0700 | [diff] [blame] | 781 | fi |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 782 | test_at_end_hook_ |
| 783 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 784 | exit 0 ;; |
| 785 | |
| 786 | *) |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 787 | if test $test_external_has_tap -eq 0 |
| 788 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 789 | say_color error "# failed $test_failure among $msg" |
| 790 | say "1..$test_count" |
Ævar Arnfjörð Bjarmason | d998bd4 | 2010-06-24 17:44:46 +0000 | [diff] [blame] | 791 | fi |
Ævar Arnfjörð Bjarmason | 5099b99 | 2010-06-24 21:52:12 +0000 | [diff] [blame] | 792 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 793 | exit 1 ;; |
| 794 | |
| 795 | esac |
| 796 | } |
| 797 | |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 798 | if test -n "$valgrind" |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 799 | then |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 800 | make_symlink () { |
| 801 | test -h "$2" && |
| 802 | test "$1" = "$(readlink "$2")" || { |
| 803 | # be super paranoid |
| 804 | if mkdir "$2".lock |
| 805 | then |
| 806 | rm -f "$2" && |
| 807 | ln -s "$1" "$2" && |
| 808 | rm -r "$2".lock |
| 809 | else |
| 810 | while test -d "$2".lock |
| 811 | do |
| 812 | say "Waiting for lock on $2." |
| 813 | sleep 1 |
| 814 | done |
| 815 | fi |
| 816 | } |
| 817 | } |
| 818 | |
| 819 | make_valgrind_symlink () { |
Jeff King | 36bfb0e | 2011-06-17 16:36:32 -0400 | [diff] [blame] | 820 | # handle only executables, unless they are shell libraries that |
Jonathan Nieder | 11d6214 | 2013-11-25 13:03:52 -0800 | [diff] [blame] | 821 | # need to be in the exec-path. |
Jeff King | 36bfb0e | 2011-06-17 16:36:32 -0400 | [diff] [blame] | 822 | test -x "$1" || |
Jonathan Nieder | 11d6214 | 2013-11-25 13:03:52 -0800 | [diff] [blame] | 823 | test "# " = "$(head -c 2 <"$1")" || |
Jeff King | 36bfb0e | 2011-06-17 16:36:32 -0400 | [diff] [blame] | 824 | return; |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 825 | |
| 826 | base=$(basename "$1") |
René Scharfe | 28fab7b | 2016-10-28 00:14:00 +0200 | [diff] [blame] | 827 | case "$base" in |
| 828 | test-*) |
| 829 | symlink_target="$GIT_BUILD_DIR/t/helper/$base" |
| 830 | ;; |
| 831 | *) |
| 832 | symlink_target="$GIT_BUILD_DIR/$base" |
| 833 | ;; |
| 834 | esac |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 835 | # do not override scripts |
| 836 | if test -x "$symlink_target" && |
| 837 | test ! -d "$symlink_target" && |
| 838 | test "#!" != "$(head -c 2 < "$symlink_target")" |
| 839 | then |
| 840 | symlink_target=../valgrind.sh |
| 841 | fi |
Johannes Schindelin | efd92ff | 2009-02-04 00:26:08 +0100 | [diff] [blame] | 842 | case "$base" in |
| 843 | *.sh|*.perl) |
| 844 | symlink_target=../unprocessed-script |
| 845 | esac |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 846 | # create the link, or replace it if it is out of date |
| 847 | make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit |
| 848 | } |
| 849 | |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 850 | # override all git executables in TEST_DIRECTORY/.. |
| 851 | GIT_VALGRIND=$TEST_DIRECTORY/valgrind |
| 852 | mkdir -p "$GIT_VALGRIND"/bin |
Johannes Schindelin | 503e224 | 2016-07-11 13:45:08 +0200 | [diff] [blame] | 853 | for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-* |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 854 | do |
| 855 | make_valgrind_symlink $file |
| 856 | done |
| 857 | # special-case the mergetools loadables |
| 858 | make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools" |
| 859 | OLDIFS=$IFS |
| 860 | IFS=: |
| 861 | for path in $PATH |
| 862 | do |
| 863 | ls "$path"/git-* 2> /dev/null | |
| 864 | while read file |
Johannes Schindelin | efd92ff | 2009-02-04 00:26:08 +0100 | [diff] [blame] | 865 | do |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 866 | make_valgrind_symlink "$file" |
Johannes Schindelin | efd92ff | 2009-02-04 00:26:08 +0100 | [diff] [blame] | 867 | done |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 868 | done |
| 869 | IFS=$OLDIFS |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 870 | PATH=$GIT_VALGRIND/bin:$PATH |
| 871 | GIT_EXEC_PATH=$GIT_VALGRIND/bin |
| 872 | export GIT_VALGRIND |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 873 | GIT_VALGRIND_MODE="$valgrind" |
| 874 | export GIT_VALGRIND_MODE |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 875 | GIT_VALGRIND_ENABLED=t |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 876 | test -n "$valgrind_only" && GIT_VALGRIND_ENABLED= |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 877 | export GIT_VALGRIND_ENABLED |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 878 | elif test -n "$GIT_TEST_INSTALLED" |
| 879 | then |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 880 | GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) || |
| 881 | error "Cannot run git from $GIT_TEST_INSTALLED." |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 882 | PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 883 | GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH} |
| 884 | else # normal case, use ../bin-wrappers only unless $with_dashes: |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 885 | git_bin_dir="$GIT_BUILD_DIR/bin-wrappers" |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 886 | if ! test -x "$git_bin_dir/git" |
| 887 | then |
| 888 | if test -z "$with_dashes" |
| 889 | then |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 890 | say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH" |
| 891 | fi |
| 892 | with_dashes=t |
| 893 | fi |
| 894 | PATH="$git_bin_dir:$PATH" |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 895 | GIT_EXEC_PATH=$GIT_BUILD_DIR |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 896 | if test -n "$with_dashes" |
| 897 | then |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 898 | PATH="$GIT_BUILD_DIR:$PATH" |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 899 | fi |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 900 | fi |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 901 | GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt |
Jeff King | 8bfa6bd | 2008-02-06 05:11:53 -0500 | [diff] [blame] | 902 | GIT_CONFIG_NOSYSTEM=1 |
Jonathan Nieder | 3c995be | 2011-03-15 04:05:10 -0500 | [diff] [blame] | 903 | GIT_ATTR_NOSYSTEM=1 |
Jonathan Nieder | 8f323c0 | 2011-03-15 04:04:49 -0500 | [diff] [blame] | 904 | export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM |
Junio C Hamano | 49ccb08 | 2005-12-07 21:52:28 -0800 | [diff] [blame] | 905 | |
Junio C Hamano | 5e87eae | 2010-06-11 09:40:25 -0700 | [diff] [blame] | 906 | if test -z "$GIT_TEST_CMP" |
| 907 | then |
| 908 | if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT" |
| 909 | then |
| 910 | GIT_TEST_CMP="$DIFF -c" |
| 911 | else |
| 912 | GIT_TEST_CMP="$DIFF -u" |
| 913 | fi |
| 914 | fi |
| 915 | |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 916 | GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git |
Petr Baudis | 6fcca93 | 2006-07-03 23:16:32 +0200 | [diff] [blame] | 917 | export GITPERLLIB |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 918 | test -d "$GIT_BUILD_DIR"/templates/blt || { |
Junio C Hamano | eea4206 | 2005-12-10 20:55:32 -0800 | [diff] [blame] | 919 | error "You haven't built things yet, have you?" |
| 920 | } |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 921 | |
Nguyễn Thái Ngọc Duy | e6e7530 | 2016-04-13 20:22:42 +0700 | [diff] [blame] | 922 | if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 923 | then |
Eric Wong | 56cf980 | 2007-02-24 16:59:52 -0800 | [diff] [blame] | 924 | echo >&2 'You need to build test-chmtime:' |
Nguyễn Thái Ngọc Duy | e6e7530 | 2016-04-13 20:22:42 +0700 | [diff] [blame] | 925 | echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory' |
Eric Wong | 56cf980 | 2007-02-24 16:59:52 -0800 | [diff] [blame] | 926 | exit 1 |
| 927 | fi |
| 928 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 929 | # Test repository |
Jeff King | 002d4ce | 2013-04-14 15:38:21 -0400 | [diff] [blame] | 930 | TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)" |
| 931 | test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY" |
| 932 | case "$TRASH_DIRECTORY" in |
| 933 | /*) ;; # absolute path is good |
| 934 | *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;; |
Jeff King | f423ef5 | 2009-08-09 04:39:45 -0400 | [diff] [blame] | 935 | esac |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 936 | rm -fr "$TRASH_DIRECTORY" || { |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 937 | GIT_EXIT_OK=t |
Junio C Hamano | 8d14ac9 | 2008-03-18 21:58:01 -0700 | [diff] [blame] | 938 | echo >&5 "FATAL: Cannot prepare test area" |
| 939 | exit 1 |
| 940 | } |
| 941 | |
Alex Riesen | 90cff96 | 2011-03-26 19:46:34 +0100 | [diff] [blame] | 942 | HOME="$TRASH_DIRECTORY" |
Junio C Hamano | 0ea47f9 | 2014-09-15 14:59:00 -0700 | [diff] [blame] | 943 | GNUPGHOME="$HOME/gnupg-home-not-used" |
| 944 | export HOME GNUPGHOME |
Alex Riesen | 90cff96 | 2011-03-26 19:46:34 +0100 | [diff] [blame] | 945 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 946 | if test -z "$TEST_NO_CREATE_REPO" |
| 947 | then |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 948 | test_create_repo "$TRASH_DIRECTORY" |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 949 | else |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 950 | mkdir -p "$TRASH_DIRECTORY" |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 951 | fi |
Lea Wiemann | 1bd9c64 | 2008-05-31 23:11:21 +0200 | [diff] [blame] | 952 | # Use -P to resolve symlinks in our working directory so that the cwd |
| 953 | # in subprocesses like git equals our $PWD (for pathname comparisons). |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 954 | cd -P "$TRASH_DIRECTORY" || exit 1 |
Junio C Hamano | 04ece59 | 2006-12-28 17:58:00 -0800 | [diff] [blame] | 955 | |
Johannes Sixt | d5d9de1 | 2009-02-05 20:59:27 +0100 | [diff] [blame] | 956 | this_test=${0##*/} |
| 957 | this_test=${this_test%%-*} |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 958 | if match_pattern_list "$this_test" $GIT_SKIP_TESTS |
| 959 | then |
| 960 | say_color info >&3 "skipping test $this_test altogether" |
| 961 | skip_all="skip all tests in $this_test" |
| 962 | test_done |
| 963 | fi |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 964 | |
Brandon Casey | 8648732 | 2009-08-28 17:32:41 -0500 | [diff] [blame] | 965 | # Provide an implementation of the 'yes' utility |
| 966 | yes () { |
| 967 | if test $# = 0 |
| 968 | then |
| 969 | y=y |
| 970 | else |
| 971 | y="$*" |
| 972 | fi |
| 973 | |
Johannes Schindelin | 6129c93 | 2016-02-02 19:15:53 +0100 | [diff] [blame] | 974 | i=0 |
| 975 | while test $i -lt 99 |
Brandon Casey | 8648732 | 2009-08-28 17:32:41 -0500 | [diff] [blame] | 976 | do |
Johannes Schindelin | 6129c93 | 2016-02-02 19:15:53 +0100 | [diff] [blame] | 977 | echo "$y" |
| 978 | i=$(($i+1)) |
Brandon Casey | 8648732 | 2009-08-28 17:32:41 -0500 | [diff] [blame] | 979 | done |
| 980 | } |
| 981 | |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 982 | # Fix some commands on Windows |
Johannes Schindelin | d98b2c5 | 2016-07-21 18:02:54 +0200 | [diff] [blame] | 983 | uname_s=$(uname -s) |
| 984 | case $uname_s in |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 985 | *MINGW*) |
| 986 | # Windows has its own (incompatible) sort and find |
| 987 | sort () { |
| 988 | /usr/bin/sort "$@" |
| 989 | } |
| 990 | find () { |
| 991 | /usr/bin/find "$@" |
| 992 | } |
Johannes Sixt | 4114156 | 2009-03-13 23:35:24 +0100 | [diff] [blame] | 993 | # git sees Windows-style pwd |
| 994 | pwd () { |
| 995 | builtin pwd -W |
| 996 | } |
Johannes Sixt | ee9fb68 | 2009-03-13 22:55:27 +0100 | [diff] [blame] | 997 | # no POSIX permissions |
Johannes Sixt | 6fd1106 | 2009-03-13 23:00:15 +0100 | [diff] [blame] | 998 | # backslashes in pathspec are converted to '/' |
Johannes Sixt | fb9a2be | 2009-03-25 13:21:15 +0100 | [diff] [blame] | 999 | # exec does not inherit the PID |
Pat Thoyts | a94114a | 2010-09-12 10:37:24 +0100 | [diff] [blame] | 1000 | test_set_prereq MINGW |
Brice Lambson | 5f4e02e | 2014-08-30 23:39:07 +0200 | [diff] [blame] | 1001 | test_set_prereq NATIVE_CRLF |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 1002 | test_set_prereq SED_STRIPS_CR |
Mark Levedahl | 97669ee | 2013-07-18 17:44:57 -0400 | [diff] [blame] | 1003 | test_set_prereq GREP_STRIPS_CR |
Johannes Sixt | 4d715ac | 2013-10-26 21:17:15 +0200 | [diff] [blame] | 1004 | GIT_TEST_CMP=mingw_test_cmp |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 1005 | ;; |
| 1006 | *CYGWIN*) |
| 1007 | test_set_prereq POSIXPERM |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 1008 | test_set_prereq EXECKEEPSPID |
Pete Wyckoff | cfa9649 | 2013-01-26 22:11:11 -0500 | [diff] [blame] | 1009 | test_set_prereq CYGWIN |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 1010 | test_set_prereq SED_STRIPS_CR |
Mark Levedahl | 97669ee | 2013-07-18 17:44:57 -0400 | [diff] [blame] | 1011 | test_set_prereq GREP_STRIPS_CR |
Johannes Sixt | ee9fb68 | 2009-03-13 22:55:27 +0100 | [diff] [blame] | 1012 | ;; |
| 1013 | *) |
| 1014 | test_set_prereq POSIXPERM |
Johannes Sixt | 6fd1106 | 2009-03-13 23:00:15 +0100 | [diff] [blame] | 1015 | test_set_prereq BSLASHPSPEC |
Johannes Sixt | fb9a2be | 2009-03-25 13:21:15 +0100 | [diff] [blame] | 1016 | test_set_prereq EXECKEEPSPID |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 1017 | ;; |
| 1018 | esac |
Johannes Sixt | 704a314 | 2009-03-04 22:38:24 +0100 | [diff] [blame] | 1019 | |
Zbigniew Jędrzejewski-Szmek | b082687 | 2012-04-27 11:25:25 +0200 | [diff] [blame] | 1020 | ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1 |
Jeff King | 1b19ccd | 2009-04-03 15:33:59 -0400 | [diff] [blame] | 1021 | test -z "$NO_PERL" && test_set_prereq PERL |
Ævar Arnfjörð Bjarmason | 68c7d27 | 2017-05-25 19:45:31 +0000 | [diff] [blame] | 1022 | test -z "$NO_PTHREADS" && test_set_prereq PTHREADS |
Johan Herland | d4e1b47 | 2009-11-18 02:42:31 +0100 | [diff] [blame] | 1023 | test -z "$NO_PYTHON" && test_set_prereq PYTHON |
Ævar Arnfjörð Bjarmason | 94da919 | 2017-06-01 18:20:56 +0000 | [diff] [blame] | 1024 | test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE |
Ævar Arnfjörð Bjarmason | 5e9637c | 2011-11-18 00:14:42 +0100 | [diff] [blame] | 1025 | test -z "$NO_GETTEXT" && test_set_prereq GETTEXT |
Jeff King | 1b19ccd | 2009-04-03 15:33:59 -0400 | [diff] [blame] | 1026 | |
Ævar Arnfjörð Bjarmason | bb946bb | 2011-02-22 23:41:21 +0000 | [diff] [blame] | 1027 | # Can we rely on git's output in the C locale? |
Jonathan Nieder | 3095522 | 2011-02-22 23:41:22 +0000 | [diff] [blame] | 1028 | if test -n "$GETTEXT_POISON" |
| 1029 | then |
| 1030 | GIT_GETTEXT_POISON=YesPlease |
| 1031 | export GIT_GETTEXT_POISON |
Ævar Arnfjörð Bjarmason | 5e9637c | 2011-11-18 00:14:42 +0100 | [diff] [blame] | 1032 | test_set_prereq GETTEXT_POISON |
Jonathan Nieder | 3095522 | 2011-02-22 23:41:22 +0000 | [diff] [blame] | 1033 | else |
| 1034 | test_set_prereq C_LOCALE_OUTPUT |
| 1035 | fi |
Ævar Arnfjörð Bjarmason | bb946bb | 2011-02-22 23:41:21 +0000 | [diff] [blame] | 1036 | |
Junio C Hamano | cabdee2 | 2011-04-12 11:23:23 -0700 | [diff] [blame] | 1037 | # Use this instead of test_cmp to compare files that contain expected and |
| 1038 | # actual output from git commands that can be translated. When running |
| 1039 | # under GETTEXT_POISON this pretends that the command produced expected |
| 1040 | # results. |
| 1041 | test_i18ncmp () { |
| 1042 | test -n "$GETTEXT_POISON" || test_cmp "$@" |
| 1043 | } |
| 1044 | |
Junio C Hamano | 127df8c | 2011-04-12 15:57:08 -0700 | [diff] [blame] | 1045 | # Use this instead of "grep expected-string actual" to see if the |
| 1046 | # output from a git command that can be translated either contains an |
| 1047 | # expected string, or does not contain an unwanted one. When running |
| 1048 | # under GETTEXT_POISON this pretends that the command produced expected |
| 1049 | # results. |
| 1050 | test_i18ngrep () { |
| 1051 | if test -n "$GETTEXT_POISON" |
| 1052 | then |
| 1053 | : # pretend success |
| 1054 | elif test "x!" = "x$1" |
| 1055 | then |
| 1056 | shift |
| 1057 | ! grep "$@" |
| 1058 | else |
| 1059 | grep "$@" |
| 1060 | fi |
| 1061 | } |
| 1062 | |
Adam Spiers | 2007327 | 2013-04-11 03:07:04 +0100 | [diff] [blame] | 1063 | test_lazy_prereq PIPE ' |
| 1064 | # test whether the filesystem supports FIFOs |
Mark Levedahl | 9443605 | 2013-07-04 18:04:30 -0400 | [diff] [blame] | 1065 | case $(uname -s) in |
Johannes Schindelin | a1f3296 | 2016-01-27 17:19:43 +0100 | [diff] [blame] | 1066 | CYGWIN*|MINGW*) |
Mark Levedahl | 9443605 | 2013-07-04 18:04:30 -0400 | [diff] [blame] | 1067 | false |
| 1068 | ;; |
| 1069 | *) |
| 1070 | rm -f testfifo && mkfifo testfifo |
| 1071 | ;; |
| 1072 | esac |
Adam Spiers | 2007327 | 2013-04-11 03:07:04 +0100 | [diff] [blame] | 1073 | ' |
| 1074 | |
Junio C Hamano | 04083f2 | 2012-07-26 15:50:45 -0700 | [diff] [blame] | 1075 | test_lazy_prereq SYMLINKS ' |
| 1076 | # test whether the filesystem supports symbolic links |
| 1077 | ln -s x y && test -h y |
| 1078 | ' |
Ævar Arnfjörð Bjarmason | c91cfd1 | 2010-08-06 22:09:09 +0000 | [diff] [blame] | 1079 | |
Jonathan Nieder | b018c73 | 2013-11-25 13:02:16 -0800 | [diff] [blame] | 1080 | test_lazy_prereq FILEMODE ' |
| 1081 | test "$(git config --bool core.filemode)" = true |
| 1082 | ' |
| 1083 | |
Michael J Gruber | ac39aa6 | 2012-07-26 15:39:53 +0200 | [diff] [blame] | 1084 | test_lazy_prereq CASE_INSENSITIVE_FS ' |
| 1085 | echo good >CamelCase && |
| 1086 | echo bad >camelcase && |
| 1087 | test "$(cat CamelCase)" != good |
| 1088 | ' |
| 1089 | |
Michael J Gruber | 5b0b5dd | 2012-07-26 15:39:56 +0200 | [diff] [blame] | 1090 | test_lazy_prereq UTF8_NFD_TO_NFC ' |
| 1091 | # check whether FS converts nfd unicode to nfc |
| 1092 | auml=$(printf "\303\244") |
| 1093 | aumlcdiar=$(printf "\141\314\210") |
| 1094 | >"$auml" && |
| 1095 | case "$(echo *)" in |
| 1096 | "$aumlcdiar") |
| 1097 | true ;; |
| 1098 | *) |
| 1099 | false ;; |
| 1100 | esac |
| 1101 | ' |
| 1102 | |
Jeff King | 09feffb | 2012-11-14 16:33:40 -0800 | [diff] [blame] | 1103 | test_lazy_prereq AUTOIDENT ' |
| 1104 | sane_unset GIT_AUTHOR_NAME && |
| 1105 | sane_unset GIT_AUTHOR_EMAIL && |
| 1106 | git var GIT_AUTHOR_IDENT |
| 1107 | ' |
| 1108 | |
Junio C Hamano | 6219bb2 | 2014-06-09 12:23:30 -0700 | [diff] [blame] | 1109 | test_lazy_prereq EXPENSIVE ' |
| 1110 | test -n "$GIT_TEST_LONG" |
| 1111 | ' |
| 1112 | |
Junio C Hamano | e1ecd9e | 2014-06-09 13:54:25 -0700 | [diff] [blame] | 1113 | test_lazy_prereq USR_BIN_TIME ' |
| 1114 | test -x /usr/bin/time |
| 1115 | ' |
| 1116 | |
Jeff King | 1767c51 | 2015-01-16 04:16:49 -0500 | [diff] [blame] | 1117 | test_lazy_prereq NOT_ROOT ' |
| 1118 | uid=$(id -u) && |
| 1119 | test "$uid" != 0 |
| 1120 | ' |
| 1121 | |
Jonathan Tan | 63b747c | 2016-09-09 10:36:28 -0700 | [diff] [blame] | 1122 | test_lazy_prereq JGIT ' |
| 1123 | type jgit |
| 1124 | ' |
| 1125 | |
Junio C Hamano | 719c3da | 2016-01-19 14:09:37 -0800 | [diff] [blame] | 1126 | # SANITY is about "can you correctly predict what the filesystem would |
| 1127 | # do by only looking at the permission bits of the files and |
| 1128 | # directories?" A typical example of !SANITY is running the test |
| 1129 | # suite as root, where a test may expect "chmod -r file && cat file" |
| 1130 | # to fail because file is supposed to be unreadable after a successful |
| 1131 | # chmod. In an environment (i.e. combination of what filesystem is |
| 1132 | # being used and who is running the tests) that lacks SANITY, you may |
| 1133 | # be able to delete or create a file when the containing directory |
| 1134 | # doesn't have write permissions, or access a file even if the |
| 1135 | # containing directory doesn't have read or execute permissions. |
| 1136 | |
Torsten Bögershausen | f400e51 | 2015-01-27 16:39:01 +0100 | [diff] [blame] | 1137 | test_lazy_prereq SANITY ' |
| 1138 | mkdir SANETESTD.1 SANETESTD.2 && |
| 1139 | |
| 1140 | chmod +w SANETESTD.1 SANETESTD.2 && |
| 1141 | >SANETESTD.1/x 2>SANETESTD.2/x && |
| 1142 | chmod -w SANETESTD.1 && |
Junio C Hamano | 719c3da | 2016-01-19 14:09:37 -0800 | [diff] [blame] | 1143 | chmod -r SANETESTD.1/x && |
Torsten Bögershausen | f400e51 | 2015-01-27 16:39:01 +0100 | [diff] [blame] | 1144 | chmod -rx SANETESTD.2 || |
| 1145 | error "bug in test sript: cannot prepare SANETESTD" |
| 1146 | |
Junio C Hamano | 719c3da | 2016-01-19 14:09:37 -0800 | [diff] [blame] | 1147 | ! test -r SANETESTD.1/x && |
Torsten Bögershausen | f400e51 | 2015-01-27 16:39:01 +0100 | [diff] [blame] | 1148 | ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x |
| 1149 | status=$? |
| 1150 | |
| 1151 | chmod +rwx SANETESTD.1 SANETESTD.2 && |
| 1152 | rm -rf SANETESTD.1 SANETESTD.2 || |
| 1153 | error "bug in test sript: cannot clean SANETESTD" |
| 1154 | return $status |
| 1155 | ' |
Jeff King | f838ce5 | 2013-03-10 21:31:47 -0400 | [diff] [blame] | 1156 | |
Johannes Schindelin | d98b2c5 | 2016-07-21 18:02:54 +0200 | [diff] [blame] | 1157 | test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip} |
Jeff King | f838ce5 | 2013-03-10 21:31:47 -0400 | [diff] [blame] | 1158 | GIT_UNZIP=${GIT_UNZIP:-unzip} |
| 1159 | test_lazy_prereq UNZIP ' |
| 1160 | "$GIT_UNZIP" -v |
| 1161 | test $? -ne 127 |
| 1162 | ' |
Jeff King | 9a308de | 2015-03-13 00:53:07 -0400 | [diff] [blame] | 1163 | |
| 1164 | run_with_limited_cmdline () { |
| 1165 | (ulimit -s 128 && "$@") |
| 1166 | } |
| 1167 | |
| 1168 | test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true' |
Jeff King | 6b9c38e | 2016-07-11 19:54:18 -0400 | [diff] [blame] | 1169 | |
| 1170 | build_option () { |
| 1171 | git version --build-options | |
| 1172 | sed -ne "s/^$1: //p" |
| 1173 | } |
| 1174 | |
| 1175 | test_lazy_prereq LONG_IS_64BIT ' |
| 1176 | test 8 -le "$(build_option sizeof-long)" |
| 1177 | ' |
Johannes Schindelin | a07fb05 | 2017-04-20 22:52:13 +0200 | [diff] [blame] | 1178 | |
| 1179 | test_lazy_prereq TIME_IS_64BIT 'test-date is64bit' |
Johannes Schindelin | efac8ac | 2017-04-20 22:58:21 +0200 | [diff] [blame] | 1180 | test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit' |